import {
	ModuleWithProviders,
	NgModule,
	Optional,
	SkipSelf
} from '@angular/core';
import { CommonModule }      from '@angular/common';

import {
	LocalStorageService,
	LocalStorageServiceConfig
} from './localstorage.service';

@NgModule({
	imports: [
		CommonModule
	],
	providers: [
		LocalStorageService
	]
})
export class LocalStorageModule {
	
	constructor(@Optional() @SkipSelf() parentModule: LocalStorageModule) {
		if (parentModule) {
			throw new Error(
				'LocalStorageModule is already loaded. Import it in the AppModule only');
		}
	}
	static forRoot(config: LocalStorageServiceConfig): ModuleWithProviders {
		return {
			ngModule: LocalStorageModule,
			providers: [
				// add provider info
				/** @Example: */
				 {provide: LocalStorageServiceConfig, useValue: config }
			]
		};
	}
}
